public class FourStateBBStrategy implements Strategy {
	public void compute(TuringMachine tm) {
		if (tm.readChar())
		{
			if (tm.getCurrState() == 1)
			{
				tm.writeChar(true);
				tm.moveTapeHead(-1);
				tm.setCurrState(2);
			}
			else if (tm.getCurrState() == 2)
			{
				tm.writeChar(false);
				tm.moveTapeHead(-1);
				tm.setCurrState(3);
			}
			else if (tm.getCurrState() == 3)
			{
				tm.writeChar(true);
				tm.moveTapeHead(-1);
				tm.setCurrState(4);
			}
			else if (tm.getCurrState() == 4)
			{
				tm.writeChar(false);
				tm.moveTapeHead(1);
				tm.setCurrState(1);
			}
		}
		else
		{
			if (tm.getCurrState() == 1)
			{
				tm.writeChar(true);
				tm.moveTapeHead(1);
				tm.setCurrState(2);
			}
			else if (tm.getCurrState() == 2)
			{
				tm.writeChar(true);
				tm.moveTapeHead(-1);
				tm.setCurrState(1);
			}
			else if (tm.getCurrState() == 3)
			{
				tm.writeChar(true);
				tm.moveTapeHead(1);
				tm.setCurrState(0);
			}
			else if (tm.getCurrState() == 4)
			{
				tm.writeChar(true);
				tm.moveTapeHead(1);
				tm.setCurrState(4);
			}
		}
	}

	public int getNumState() {
		return 4;
	}

	public String toString() {
		return "Four State Busy Beaver";
	}
}