public class TuringMachine {
	public static final int LENGTH = 300;

	private Strategy strategy;
	private int currState;
	private int tapeHead;
	private int oldTapeHead;
	private boolean[] cells = new boolean[LENGTH];

	public TuringMachine() {
	}

	public void setStrategy(Strategy strategy) {
		this.strategy = strategy;
	}

	public boolean getOldChar() {
		return cells[oldTapeHead];
	}

	public int getOldTapeHead() {
		return oldTapeHead;
	}

	public boolean readChar() {
		return cells[tapeHead];
	}

	public void reset(int state, int head) {
		cells = new boolean[LENGTH];
		this.currState = state;
		this.tapeHead = head;
	}

	public void setCurrState(int currState) {
		this.currState = currState;
	}

	public int getCurrState() {
		return currState;
	}

	public void moveTapeHead(int delta) {
		oldTapeHead = tapeHead;
		tapeHead += delta;
	}

	public int getTapeHead() {
		return tapeHead;
	}

	public void writeChar(boolean value) {
		cells[tapeHead] = value;
	}

	public boolean compute() {
//		System.out.println("Turing Machine: tapeHead=" + tapeHead + ", char=" + cells[tapeHead] + ", currState=" + currState);
		strategy.compute(this);
		return currState == 0;
	}
}
