public class TwoStateBBStrategy implements Strategy {
	public void compute(TuringMachine tm) {
		if (!tm.readChar())
		{
			if (tm.getCurrState() == 1)
			{
				tm.writeChar(true);
				tm.moveTapeHead(-1);
				tm.setCurrState(2);
			}
			else if (tm.getCurrState() == 2)
			{
				tm.writeChar(true);
				tm.moveTapeHead(1);
				tm.setCurrState(1);
			}
		}
		else if (tm.readChar())
		{
			if (tm.getCurrState() == 1)
			{
				tm.writeChar(true);
				tm.moveTapeHead(1);
				tm.setCurrState(2);
			}
			else
			{
				tm.writeChar(true);
				tm.moveTapeHead(1);
				tm.setCurrState(0);
			}
		}
	}

	public int getNumState() {
		return 2;
	}

	public String toString() {
		return "Two State Busy Beaver";
	}
}